PrefabFiles = {
	"yuyuko",
	"yuyuko_none",
}

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/yuyuko.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/yuyuko.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/yuyuko.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/yuyuko.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/yuyuko_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/yuyuko_silho.xml" ),

    Asset( "IMAGE", "bigportraits/yuyuko.tex" ),
    Asset( "ATLAS", "bigportraits/yuyuko.xml" ),
	
	Asset( "IMAGE", "images/map_icons/yuyuko.tex" ),
	Asset( "ATLAS", "images/map_icons/yuyuko.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_yuyuko.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_yuyuko.xml" ),
	
	Asset( "IMAGE", "images/avatars/avatar_ghost_yuyuko.tex" ),
    Asset( "ATLAS", "images/avatars/avatar_ghost_yuyuko.xml" ),
	
	Asset( "IMAGE", "images/avatars/self_inspect_yuyuko.tex" ),
    Asset( "ATLAS", "images/avatars/self_inspect_yuyuko.xml" ),
	
	Asset( "IMAGE", "images/names_yuyuko.tex" ),
    Asset( "ATLAS", "images/names_yuyuko.xml" ),
	
    Asset( "IMAGE", "bigportraits/yuyuko_none.tex" ),
    Asset( "ATLAS", "bigportraits/yuyuko_none.xml" ),

}

local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS

-- The character select screen lines
STRINGS.CHARACTER_TITLES.yuyuko = "The Ghost Princess"
STRINGS.CHARACTER_NAMES.yuyuko = "Yuyuko Saigyouji"
STRINGS.CHARACTER_DESCRIPTIONS.yuyuko = "*Is a ghost\n*Eats a lot\n*Can make people die"
STRINGS.CHARACTER_QUOTES.yuyuko = "\"Let's go on a wonderful midnight snack tour!\""

-- Custom speech strings
STRINGS.CHARACTERS.YUYUKO = require "speech_yuyuko"

-- The character's name as appears in-game 
STRINGS.NAMES.YUYUKO = "Yuyuko"

AddMinimapAtlas("images/map_icons/yuyuko.xml")

---let's try this...

local function NonSaneGhost(inst)

	OldSanityCal = inst.components.sanityaura.aurafn
	inst.components.sanityaura.aurafn = function(instance, observer)
		return observer:HasTag("yuyuko") and 0 or OldSanityCal(instance, observer)
	end
end

-- check screen
local function IsDefaultScreen() 
	if GLOBAL.TheFrontEnd:GetActiveScreen() and GLOBAL.TheFrontEnd:GetActiveScreen().name and type(GLOBAL.TheFrontEnd:GetActiveScreen().name) == "string" and GLOBAL.TheFrontEnd:GetActiveScreen().name == "HUD" then
		return true
	else
		return false
	end
end

-- KILL
local function Beckon(player, x, y, z)
	if player:HasTag("yuyuko") and not player.sg:HasStateTag("busy") and not player.sg:HasStateTag("sleeping") then
		local ents = TheSim:FindEntities(x, y, z, 5)
		if ents then 
			for i, target in ipairs(ents) do
				print(target.name)
				if target ~= player then
					player:beckon(target)
					return 
				end
			end
			print("no ents found on server")
		end
	else
		print("Not Yuyuko, or was busy / sleeping.")
	end
end	

-- Add RPC
AddModRPCHandler(modname, "Beckon", Beckon)

-- TODO: add config
GLOBAL.TheInput:AddKeyDownHandler(99, function()
	local player = GLOBAL.ThePlayer
	if player and player:HasTag("yuyuko") and not player.HUD:IsChatInputScreenOpen() and not player.HUD:IsConsoleScreenOpen() and IsDefaultScreen() then
		local target = GLOBAL.TheInput:GetWorldEntityUnderMouse()
		if target then
			if not GLOBAL.TheWorld.ismastersim then 
				local x, y, z = target.Transform:GetWorldPosition()
				SendModRPCToServer(MOD_RPC[modname]["Beckon"], x, y, z)
			else
				player:beckon(target)
			end
		else 
			print("No target found in event.")
		end
	else
		print("Command failed.")
	end
end)

AddModCharacter("yuyuko", "FEMALE")
AddPrefabPostInit("ghost", NonSaneGhost)


